/* Panorama Tools Open GUI
   Copyright (C) 2003 -

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*------------------------------------------------------------*/

//---------------------------------------------------------------------------
#ifdef __BORLANDC__
  #pragma hdrstop
#endif

#include "ptopengui_parser.h"
#include <string.h>
#include <ctype.h>
#include <locale.h>
#include <stdio.h>
#ifdef __BORLANDC__
  #include <mem.h>
#endif

//---------------------------------------------------------------------------

//---------------

#define MY_SSCANF( str, format, ptr, varName)	if( sscanf( str, format, ptr ) != 1 )   \
		{										\
				FLastResult = -1;\
				PrintError("Could not assign variable: " varName);\
				PrintError( 						\
				"Syntax error in script: Line %d",\
				lineNum,true);							\
				return FLastResult;							\
		}


#define READ_VAR(format, ptr, varName)	 nextWord( buf, &li );	MY_SSCANF( buf, format, ptr, varName);


#define READ_OPT_VAR(var)		nextWord( buf, &li );			\
				MY_SSCANF( buf, "%ld", &k,#var);		\
				if( k<0 || k>= numIm )			\
				{								\
						FLastResult = -1;\
						PrintError("Syntax error in script: Line %d", lineNum);	\
						return FLastResult;					\
				}								\
				if( gl->opt[k].var )			\
				{								\
						FLastResult = -1;\
						PrintError("Conflict in script: Line %d\nMultiple Instances of Variable", lineNum);	\
						return FLastResult;					\
				}								\
				gl->opt[k].var	 = 1;			\
				n++;							\

//------------------

#define MAX_LINE_LEN 260
#define MAX_COMMENT_LEN 200


#if 0

BCB ide functions

//---------------------------------------------------------------------------
 TFormParser::TFormParser(TComponent* Owner)
		: TForm(Owner)
{
		Fgl = 0;
		//Freread = false;
}
//---------------------------------------------------------------------------
void  TFormParser::FreeImAlignInfo(GuiAlignInfo *gl,int imNr)
{
	if (gl->im[imNr].name) {
		delete [] gl->im[imNr].name;
		gl->im[imNr].name = 0;
	}
}
int  TFormParser::FreeAlignInfo(GuiAlignInfo *gl)
{
	int i;

	for (i=0; i<gl->numIm; i++) {
		FreeImAlignInfo(gl,i);
	}
	if (gl->pano.name) {
		delete [] gl->pano.name;
	}
	if (gl->projDir) {
		delete [] gl->projDir;
	}
	if (gl->im) {
		//mem_free(gl->im);
		delete [] gl->im;
	}
	if (gl->opt) {
		//mem_free(gl->opt);
		delete [] gl->opt;
	}
	if (gl->cpt) {
		for (i=0; i<gl->numMaxPts; i++) {
			// clear all comments
			if (gl->cpt[i].comment) {
				//mem_free(gl->cpt[i].comment);
				delete [] gl->cpt[i].comment;
			}
		}
		//mem_free(gl->cpt);
		delete [] gl->cpt;
	}
	if (gl->t)
		//mem_free(gl->t);
		delete [] gl->t;
	if (gl->cim)
		//mem_free(gl->cim);
		delete [] gl->cim;
	gl->im 	= NULL;
	gl->opt = NULL;
	gl->cpt	= NULL;
	gl->t 	= NULL;
	gl->cim = NULL;
	gl->pano.name = NULL;
	gl->projDir = NULL;
	if (gl->st.srcName) {
		delete [] gl->st.srcName;
		gl->st.srcName = 0;
	}
	if (gl->st.destName) {
		delete [] gl->st.destName;
		gl->st.destName = 0;
	}

	// Determine number of images and control points

	// gl is now empty
	gl->numIm 	= 0;
	gl->numPts 	= 0;
	gl->nt 		= 0;
	gl->numMaxIm = 0;
	gl->numMaxPts = 0;
	// other parameters
	gl->refImNr = -1;
	gl->jpegQ = 90;
	gl->jpegProgressive = 0;
	gl->lensFocalLength = 50;
	if (Fgl == gl) {
		Fgl = 0;
	}
	return 0;
}
char * TFormParser::AllocComment(char *s_in)
{
	int len;
	char *s_out;
	if (*s_in == ' ')
		s_in++;
	len = strlen(s_in);
	if (!len) {
		return 0;
	}
	//s_out = (char*)malloc(sizeof(char)*len+1);
	//s_out = (char*)mem_malloc(sizeof(char)*len+1);
	s_out = new char[sizeof(char)*len+1];
	if (s_out) {
		strcpy(s_out,s_in);
		if (len > MAX_COMMENT_LEN) {
			s_out[MAX_COMMENT_LEN-1] = 0;
		}
	}
	return s_out;
}
char * TFormParser::AllocString(char *s_in, char *s_old)
{
	int len;
	char *s_out;
	/*if (s_in && s_old && !strcmp(s_in,s_out)) {
		// already same, keep old value
		return s_old;
	}*/
	if (s_old) {
		delete [] s_old;
	}
	if (!s_in) {
		return 0;
	}
	len = strlen(s_in);
	if (!len) {
		return 0;
	}
	//s_out = (char*)malloc(sizeof(char)*len+1);
	//s_out = (char*)mem_malloc(sizeof(char)*len+1);
	s_out = new char[sizeof(char)*len+1];
	strcpy(s_out,s_in);
	return s_out;
}
void  TFormParser::FreeComment(char *s_in)
{
	if (s_in) {
		//mem_free(s_in);
		delete [] s_in;
	}
	return ;
}
void * TFormParser::ResizeMem(void *ptr, long new_size, long old_size)
{
	char *new_data;
	if (new_size == old_size) {
		// no change
		return ptr;
	}
	new_data = new char [new_size/sizeof(char)];
	memcpy(new_data,ptr, new_size > old_size? old_size:new_size);
	return new_data;
}
//---------------------------------------------------------------------------
int  TFormParser::ReserveSpace4Image2AlignInfo(GuiAlignInfo *gl)
{
	int oldNum;
	if (gl->numIm >= gl->numMaxIm) {
		// set how much to copy mem
		oldNum = gl->numMaxIm;
		// set new limit
		gl->numMaxIm = gl->numIm + 2;
		// needs more, call realloc
		//gl->im 		= (Image*)		realloc(gl->im, gl->numMaxIm 	* sizeof(Image) );
		//gl->opt		= (optVars*)	realloc(gl->opt, gl->numMaxIm 	* sizeof(optVars) );
		//gl->cim		= (CoordInfo*)	realloc(gl->cim, gl->numMaxIm 	* sizeof(CoordInfo) );
		gl->im 		= (GuiImage*)	ResizeMem(gl->im, gl->numMaxIm 	* sizeof(GuiImage), oldNum*sizeof(GuiImage));
		gl->opt		= (GuioptVars*)	ResizeMem(gl->opt, gl->numMaxIm 	* sizeof(GuioptVars), oldNum*sizeof(GuioptVars));
		gl->cim		= (CoordInfo*)	ResizeMem(gl->cim, gl->numMaxIm 	* sizeof(CoordInfo), oldNum*sizeof(CoordInfo));
		if ((gl->im == 0)||(gl->opt == 0)||(gl->cim == 0)) {
			// not enought memory
			gl->numMaxIm = gl->numIm = 0;
			return	-1;
		}
	}
	return 1;
}
void  TFormParser::SetGuiImageDefaults(GuiImage *im) {
	//im->data 		= NULL;
	im->bytesPerLine	= 0;
	im->width		= 0;
	im->height		= 0;
	im->dataSize		= 0;
	im->bitsPerPixel	= 0;
	im->format		= 0;
	im->dataformat		= _RGB;
	im->hfov		= 0.0;
	im->yaw			= 0.0;
	im->pitch		= 0.0;
	im->roll		= 0.0;
	SetCorrectDefaults( &(im->cP) );
	im->name		= 0;
	im->selection.top	= 0;
	im->selection.bottom    = 0;
	im->selection.left	= 0;
	im->selection.right	= 0;
	im->angle = 0;
}
void  TFormParser::SetGuiOptDefaults( GuioptVars *opt )
{
	opt->hfov = opt->yaw = opt->pitch = opt->roll = opt->a
	= opt->b = opt->c = opt->d = opt->e = opt->shear_x = opt->shear_y = 0;
	opt->use = opt->stitch_pre = opt->stitch_fin = 1;
}

int  TFormParser::AddImage2AlignInfo(GuiAlignInfo *gl)
{
	int i;
	// check if there is free space in arrays
	if (ReserveSpace4Image2AlignInfo(gl) < 0) {
		return 0;
	}
	// set defaults for new vectors
	//for(i=gl->numIm; i<gl->numMaxIm; i++)
	i=gl->numIm;
	{
		SetGuiImageDefaults( &(gl->im[i]) );
		SetGuiOptDefaults	( &(gl->opt[i]));
		SetCoordDefaults( &(gl->cim[i]), i);
	}
	gl->numIm++;
	return gl->numIm;
}

//---------------------------------------------------------------------------
int  TFormParser::AddControlPoint2AlignInfo(GuiAlignInfo *gl, int addCount)
{
	int i,oldNum,count;
	// search empty slot, type is invalid
	if (addCount < 1) {
		addCount = 1;
		for (i=0; i<gl->numPts; i++) {
			if (gl->cpt[i].type < 0) {
				return i;
			}
		}
	}
	// check if there is free space in arrays
	if (gl->numPts+addCount >= gl->numMaxPts) {
		//
		oldNum = gl->numMaxPts;
		// set new limit
		if (addCount <= 1) {
			count = 5;
		} else {
			count = addCount;
		}
		gl->numMaxPts = gl->numPts + count;
		// needs more, call realloc
		//gl->cpt		= (GuiControlPoint*)realloc(gl->cpt, gl->numMaxPts	* sizeof( GuiControlPoint ) );
		gl->cpt		= (GuiControlPoint*)ResizeMem(gl->cpt, gl->numMaxPts	* sizeof(GuiControlPoint), oldNum*sizeof(GuiControlPoint));
	}
	// set defaults for new vectors
	for (i=gl->numPts; i<gl->numMaxPts; i++) {
		gl->cpt[i].comment = NULL;
		gl->cpt[i].type = 0;
	}
	// add number
	gl->numPts += addCount;
	return gl->numPts-1;
}
//---------------------------------------------------------------------------
// To do: set mode for PTGui projects so that v-lines are read in a nice way
int  TFormParser::ParseScript(TStrings* src_script, GuiAlignInfo *gl, bool freshGl, bool setMemoScript)
{
	GuiImage				*im;
	GuioptVars				*opt;
	CoordInfo			*ci;

	// Variables used by parser
	int script_len;
	char 	*li, *ch;
	char 	line[MAX_LINE_LEN+2], buf[MAX_LINE_LEN+2];
	//char *lineStart;
	int 	lineNum = 0;
	int 	i,k;
	char 	lastExtraScanBuf[MAX_LINE_LEN+2] = "";		 // when PTAssembler files are read
	int		lastImageWidth, lastImageHeight;

	int 	n=0; // Number of parameters to optimize
	int		numIm,numOIm,numIIm,numPts,nt;

	setlocale(LC_ALL, "C");
	line[sizeof(line)-1] = buf[sizeof(buf)-1] = 0x5a;
	if (Fscript == 0) {
		Fscript_len = 0;
	}
	script_len = src_script->Text.Length()+1;
	if (Fscript_len < script_len) {
		if (Fscript) {
			delete [] Fscript;
		}
		Fscript_len = script_len;
		Fscript = new char[Fscript_len];	//
	}
	// copy data of object to editable space
	memcpy(Fscript,src_script->Text.c_str(),script_len);
	// copy script to Memo
	if (setMemoScript) {
		MemoScript->Lines->Assign(src_script);
	}
	MemoErrors->Clear();	// clear last errors

	if (!freshGl && (Fgl != 0)) {
		FreeAlignInfo(gl);
	} else {
		Fgl = gl;
		FLastResult = 0;        // no errors has been corrected for this read
	}

	// Determine number of images and control points

	// gl is now empty
	gl->numIm 	= numLines( Fscript, 'o' );      // was i
	gl->numPts 	= numLines( Fscript, 'c' );
	gl->nt 		= numLines( Fscript, 't' );
	// search i parameters also
	i = numLines( Fscript, 'i' );
	if (gl->numIm < i) {
		gl->numIm = i;
	} else {
	}
	// reserve memory little more than minimum need is
	gl->numMaxIm = gl->numIm;
	if (gl->numMaxIm == 0) {
		gl->numMaxIm = 1;
	}
	gl->numMaxPts 	= gl->numPts /*+ 5*/;

	// Allocate Space for Pointers to images, preferences and control points
	gl->im 		= new GuiImage[gl->numMaxIm];
	gl->opt		= new GuioptVars[gl->numMaxIm];
	gl->cpt		= new GuiControlPoint[gl->numMaxPts];
	gl->t		= new triangle[gl->nt/*==0?1:gl->nt*/];
	gl->cim		= new CoordInfo[gl->numMaxIm];

	if( gl->im == NULL || gl->opt == NULL || gl->cpt == NULL || gl->t == NULL || gl->cim == NULL )
	{
		FLastResult = -1;
		PrintError("Not enough memory",true);
		return FLastResult;
	}

	SetGuiImageDefaults(&(gl->pano));
	SetStitchDefaults(&(gl->st));
	//strcpy( gl->st.srcName, "buf" ); // Default: Use buffer 'buf' for stitching
	gl->st.srcName = AllocString("buf",gl->st.srcName);
	for(i=0; i<gl->numIm; i++)
	{
		SetGuiImageDefaults( &(gl->im[i]) );
		SetGuiOptDefaults	( &(gl->opt[i]));
		SetCoordDefaults( &(gl->cim[i]), i);
	}
	// mark all control point comments to non existent
	for (i=0; i<gl->numMaxPts; i++) {
		gl->cpt[i].comment = NULL;
	}

	numIm =numOIm=numIIm=0; numPts = 0; nt = 0; // reused as indices

	// Parse script

	ch = Fscript;

	while( *ch != 0 )
	{
		lineNum++;

		while(*ch == '\n')
			ch++;
		//lineStart = ch;

		nextLine( line, &ch );

		// parse line; use only if first character is i,p,v,c,m
		switch( line[0] )
		{
		case '#':
			// see if next is '-'
			if (line[1] == '-') {
				// handle options for project
				if (!strncmp(line+2,"imgfile",7)) {
					// read width, height and filename
					li = &(line[2+7]);
					READ_VAR( "%d", &(lastImageWidth) ,"width");
					READ_VAR( "%d", &(lastImageHeight) ,"height");
					nextWord( buf, &li );
					//sprintf( lastExtraScanBuf, "%s", buf );
					strcpy( lastExtraScanBuf, buf );
				} else if (!strncmp(line+2,"imgoptcp",8)) {
					// read width, height and filename
					li = &(line[2+8]);
					if (numIm < gl->numIm)
					READ_VAR( "%d", &(gl->opt[numIm].use) ,"imgoptcp");
					nextWord( buf, &li );
					//sprintf( lastExtraScanBuf, "%s", buf );
					strcpy( lastExtraScanBuf, buf );
				} else if (!strncmp(line+2,"imgrotate",9)) {
					// read width, height and filename
					li = &(line[2+9]);
					if (numIm < gl->numIm)
					READ_VAR( "%d", &(gl->im[numIm].angle) ,"imgrotate");
					nextWord( buf, &li );
					//sprintf( lastExtraScanBuf, "%s", buf );
					strcpy( lastExtraScanBuf, buf );
				} else if (!strncmp(line+2,"outPanoFile ",57-45)) {
					// read height, width and filename
					li = &(line[2+57-45-1]);
					nextWord( buf, &li );
					//sprintf( lastExtraScanBuf, "%s", buf );
					gl->outPanoFile = new char[strlen(buf)+1];
					strcpy(gl->outPanoFile, buf);
				} else
				if (!strncmp(line+2,"singleLensChange",16)) {
					int x;
					li = &(line[2+16]);
					READ_VAR( "%d", &(x),"singleLensChange");
					gl->changeSingleImageLensData = x != 0;
				} else
				if (!strncmp(line+2,"scanResolution",52-38)) {
					double x;
					li = &(line[2+52-38]);
					READ_VAR( "%lf", &(x),"scanResolution");
					if ((x < 10.0)||(x > 20000.0)) x = 0.0;
					gl->scanResolution = x;
				} else
				if (!strncmp(line+2,"lensSettingStyle",54-38)) {
					int x;
					li = &(line[2+54-38]);
					READ_VAR( "%d", &(x),"lensSettingStyle");
					if ((x < 0)) x = -1;
					gl->lensSettingStyle = x;
				} else
				if (!strncmp(line+2,"lensFocalLength",53-38)) {
					double x;
					li = &(line[2+53-38]);
					READ_VAR( "%lf", &(x),"lensFocalLength");
					if ((x < 0.01)||(x > 20000.0)) x = 50.0;
					gl->lensFocalLength = x;
				} else
				if (!strncmp(line+2,"jpegquality",49-38)) {
					int x;
					li = &(line[2+49-38]);
					READ_VAR( "%d", &(x),"jpegquality");
					if ((x < 0)||(x > 100)) x = 90;
					gl->jpegQ = x;
				} else
				if (!strncmp(line+2,"jpegprogressive",53-38)) {
					int x;
					li = &(line[2+53-38]);
					READ_VAR( "%d", &(x),"jpegprogressive");
					if ((x < 0)||(x > 1)) x = 0;
					gl->jpegProgressive = x;
				} else
				if (!strncmp(line+2,"refImNr",45-38)) {
					int x;
					li = &(line[2+45-38]);
					READ_VAR( "%d", &(x),"refImNr");
					if ((x < 0)||(x >= gl->numIm)) {
						x = 0;
					}
					gl->refImNr = x;
				}
			} else
			if(line[1] == '!') {// read control point comment
				int x;
				for (x=2; (x<MAX_LINE_LEN)&&(line[x]!=0)&&(line[x]!='\n')&&(line[x]!='\r'); x++)
					lastExtraScanBuf[x-2] = line[x];
				lastExtraScanBuf[x-2] = 0;
			} else
			if (!strncmp(" Control Point No",line+1,17)) {
				int ptsIndex=0;
				li = &(line[1+17]);
				READ_VAR("%d",&ptsIndex,"Control Point No");
				while ((*li == ':')||((*li != ' ')&&(*li != 0))) li++;
				while (*li == ' ') li++; li--;
				if (ptsIndex < gl->numPts) {
					READ_VAR( "%lf", &(gl->cpt[ptsIndex].ds) ,"Control Point Value");}
			}
			break;
		case 'o':
		case 'i':		// Image description
			// count o and i lines
			switch (line[0]) {
			case 'o':
				++numOIm;
				break;
			case 'i':
				++numIIm;
				break;
			}
			im	= &(gl->im[numIm]);		// This image is being set
			opt = &(gl->opt[numIm]);
			ci	= &(gl->cim[numIm]);
			// copy data from lastImage if name is set
			if (lastExtraScanBuf[0] != 0) {
				//strcpy( im->name, lastExtraScanBuf);
				im->name = AllocString(lastExtraScanBuf,im->name);
				lastExtraScanBuf[0] = 0;
				im->height = lastImageHeight;
				im->width = lastImageWidth;
			}

			li = &(line[1]);
			while( *li != 0)
			{
				switch(*li)
				{
				case 'w': 	READ_VAR( "%d", &(im->width) ,"w"); break;
				case 'h': 	READ_VAR( "%d", &(im->height),"h"); break;
				case 'v':
					if( *(li+1) == '=' ){
						li++;
						READ_VAR( "%d", &(opt->hfov),"v");
						opt->hfov += 2;
					}else{
						READ_VAR(  "%lf", &(im->hfov),"v");
					}
					break;
				case 'a':	if( *(li+1) == '=' ){
											li++;
											READ_VAR( "%d", &(opt->a),"a");
											opt->a += 2;
										}else{
											READ_VAR( "%lf", &(im->cP.radial_params[0][3]),"a");
											if (im->cP.radial_params[0][3] == 0.0) {
												im->cP.radial_params[0][3] = 0.000001;
											}
										}
										im->cP.radial 	= TRUE;
										break;
				case 'b':	if( *(li+1) == '=' ){
											li++;
											READ_VAR( "%d", &(opt->b),"b");
											opt->b += 2;
										}else{
											READ_VAR( "%lf", &(im->cP.radial_params[0][2]),"b");
											if (im->cP.radial_params[0][2] == 0.0) {
												im->cP.radial_params[0][2] = 0.000001;
											}
										}
										im->cP.radial 	= TRUE;
										break;
				case 'c':	if( *(li+1) == '=' ){
											li++;
											READ_VAR(  "%d", &(opt->c),"c");
											opt->c += 2;
										}else{
											READ_VAR( "%lf", &(im->cP.radial_params[0][1]),"c");
											if (im->cP.radial_params[0][1] == 0.0) {
												im->cP.radial_params[0][1] = 0.000001;
											}
										}
										im->cP.radial 	= TRUE;
										break;
				case 'f':
					READ_VAR( "%d", &k ,"f");
					switch (k)
					{
											case 0:   im->format = _rectilinear;	break;
											case 1:   im->format = _panorama;
														im->cP.correction_mode |= correction_mode_vertical;
														break;
											case 2:   im->format = _fisheye_circ;	break;
											case 3:   im->format = _fisheye_ff;		break;
											case 4:   im->format = _equirectangular;
														im->cP.correction_mode |= correction_mode_vertical;
														break;
											case 8:	  im->format = _orthographic; break;
											default:  FLastResult=-1;PrintError("Syntax error in script: Line %d", lineNum);
														return FLastResult;
														//break;
					}
					break;
				case 'o':	li++;
					im->cP.correction_mode |=  correction_mode_morph;
					break;
				case 'y': 	if( *(li+1) == '=' ){
											li++;
											READ_VAR( "%d", &(opt->yaw),"y");
											opt->yaw += 2;
										}else{
											READ_VAR( "%lf", &(im->yaw),"y");
										}
										break;
				case 'p': 	if( *(li+1) == '=' ){
											li++;
											READ_VAR( "%d", &(opt->pitch),"p");
											opt->pitch += 2;
										}else{
											READ_VAR("%lf", &(im->pitch),"p");
										}
										break;
				case 'r': 	if( *(li+1) == '=' ){
											li++;
											READ_VAR( "%d", &(opt->roll),"r");
											opt->roll += 2;
										}else{
											READ_VAR("%lf", &(im->roll),"r");
										}
										break;
				case 'd' :	if( *(li+1) == '=' ){
											li++;
											READ_VAR( "%d", &(opt->d),"d");
											opt->d += 2;
										}else{
											READ_VAR( "%lf", &(im->cP.horizontal_params[0]),"d");
											im->cP.horizontal= TRUE;
										}
										break;
				case 'e':	if( *(li+1) == '=' ){
											li++;
											READ_VAR( "%d", &(opt->e),"e");
											opt->e += 2;
										}else{
											READ_VAR("%lf", &(im->cP.vertical_params[0]),"e");
											im->cP.vertical	= TRUE;
										}
										break;
				case 'g':	if( *(li+1) == '=' ){
										li++;
										READ_VAR( "%d", &(opt->shear_x),"g");
										opt->shear_x += 2;
									}else{
										READ_VAR("%lf", &(im->cP.shear_x),"g");
									}
									im->cP.shear	= TRUE;
									break;
				case 't':	if( *(li+1) == '=' ){
										li++;
										READ_VAR( "%d", &(opt->shear_y),"t");
										opt->shear_y += 2;
									}else{
										READ_VAR("%lf", &(im->cP.shear_y),"t");
									}
									im->cP.shear	= TRUE;
									break;

				case 'n':			// Set filename
										nextWord( buf, &li );
										//sprintf( im->name, "%s", buf );
										im->name = AllocString(buf,im->name);
										break;
				case 'm':  // Frame
					li++;
					switch( *li )
					{
					case 'x':
						READ_VAR("%d", &(im->cP.fwidth) ,"mx");
						im->cP.cutFrame = TRUE;
						break;
					case 'y':
						READ_VAR("%d", &(im->cP.fheight) ,"my");
						im->cP.cutFrame = TRUE;
						break;
					default:
						li--;
						READ_VAR("%d", &(im->cP.frame) ,"m");
						im->cP.cutFrame = TRUE;
						break;
					}
					break;
				case 'X':	READ_VAR( "%lf", &ci->x[0] ,"X");
										break;
								case 'Y':	READ_VAR( "%lf", &ci->x[1] ,"Y");
										break;
								case 'Z':	READ_VAR( "%lf", &ci->x[2] ,"Z");
										break;
								case 'S':	nextWord( buf, &li );
									sscanf( buf, "%d,%d,%d,%d", &im->selection.left, &im->selection.right, &im->selection.top, &im->selection.bottom );
									break;
								case 'C':	nextWord( buf, &li );
									sscanf( buf, "%d,%d,%d,%d", &im->selection.left, &im->selection.right, &im->selection.top, &im->selection.bottom );
									im->cP.cutFrame = TRUE;
									break;
				case 'u':
					// feather
					//READ_VAR("%d", &(sBuf.feather) ,"u");
					//li++;
					nextWord( buf, &li );
					break;
				case '-':
				case '+':
					// skip +buf -buf
					nextWord( buf, &li );
					break;
				case ' ':
				case '\r':
					li++;	// not need to set break point for space
					break;
				default:
					li++;
					break;
				}
			}

			numIm++;
			if (numIm > gl->numMaxIm) {
				numIm--;
			}
			break;
		case 't':       // Triangle
						li = &(line[1]);
						i = 0;
						while( *li != 0) {
								switch(*li) {
								case ' ' :
								case '\t': li++; break;
								case 'i' : READ_VAR( "%ld", &(gl->t[nt].nIm),"i"); 	break;
								default  :
										if(i<3) {
												li--;
												READ_VAR( "%d", &(gl->t[nt].vert[i]) ,"default");
                                                i++;
                                        } else
                                                li++;
										break;
                                }
						}
						nt++;
						break;
		case 'c':		// Control Points

					gl->cpt[numPts].type = 0;	// default : optimize r
					if(  ReadControlPoint( &(gl->cpt[numPts]), &(line[1]) ) != 0 )
					{
												FLastResult=-1;
						PrintError("Syntax error in script: Line %d", lineNum);
						return FLastResult;
					}
					gl->cpt[numPts].comment = AllocComment(lastExtraScanBuf);
					lastExtraScanBuf[0] = 0;
					numPts++;
					break;

		case 'm':		// Mode description
					if( ReadModeDescription( &gl->sP, &(line[1]) ) != 0 )
					{
												FLastResult = -1;
						PrintError( "Syntax error in line %d" , lineNum);
						//mem_free( script );
						return FLastResult;
					}
					break;


		case 'v':		// Variables to optimize
					li = &(line[1]);
					while( *li != 0)
					{
						switch(*li)
						{
							case 'y':	READ_OPT_VAR(yaw);
										break;
							case 'p':	READ_OPT_VAR(pitch);
										break;
							case 'r':	READ_OPT_VAR(roll);
										break;
							case 'v':	READ_OPT_VAR(hfov);
										break;
							case 'a':	READ_OPT_VAR(a);
										break;
							case 'b':	READ_OPT_VAR(b);
										break;
							case 'c':	READ_OPT_VAR(c);
										break;
							case 'd':	READ_OPT_VAR(d);
										break;
							case 'e':	READ_OPT_VAR(e);
										break;
							case 'g':	READ_OPT_VAR(shear_x);
										break;
							case 't':	READ_OPT_VAR(shear_y);
										break;
							case 'X':	READ_VAR( "%d", &k ,"X");
										if( k>=0 && k<gl->numIm )
											gl->cim[k].set[0] = FALSE;
										break;
							case 'Y':	READ_VAR( "%d", &k ,"Y");
										if( k>=0 && k<gl->numIm )
											gl->cim[k].set[1] = FALSE;
										break;
							case 'Z':	READ_VAR( "%d", &k ,"Z");
										if( k>=0 && k<gl->numIm )
											gl->cim[k].set[2] = FALSE;
										break;
							default:
								li++;
								break;
						}

					}
					break;
		case 'p':		// panorama
					gl->pano.format 	= _equirectangular; // by default
					gl->pano.hfov		= 360.0;
					if( ReadImageDescription( &(gl->pano), &(gl->st), &(line[1]) ) != 0 )
					{
												FLastResult = -1;
						PrintError( "Syntax error in line %d" , lineNum,true);
						return FLastResult;
					}
					// Convert format; rectilinear and panorama ok

					if( gl->pano.format == 2 )
						gl->pano.format = _equirectangular;


					if( gl->pano.format == _rectilinear && gl->pano.hfov >= 180.0 )
					{
												FLastResult = -1;
						PrintError( "Destination image must have FOV < 180",true);
						return FLastResult;
					}
					break;
		case '*':	// End of script-data
			if (numOIm > 0) {
				FLastResult = -1;
				PrintError( "Line (%d) starts with '*' and there are output image before that, unknown file type. " , lineNum);
				return FLastResult;
			}
			// when optimized result is read it starts after this mark
			numIm = 0;
			break;
		 default:
			// unknown commands, comments...
			break;
		}
	}

	// Set up Panorama description

	if( gl->pano.width == 0 && gl->im[0].hfov != 0.0)  // Set default for panorama width based on first image
	{
		gl->pano.width = ( gl->pano.hfov / gl->im[0].hfov ) * gl->im[0].width;
		gl->pano.width /= 10; gl->pano.width *= 10; // Round to multiple of 10
	}

	if( gl->pano.height == 0 )
		gl->pano.height = gl->pano.width/2;

	if (!gl->pano.name) {
		gl->pano.name = AllocString(" ",0);
	}

//	Set up global information structure
	gl->numParam 	= n;
	//gl->data		= NULL;

// Set initial values for linked variables
	for(i=0; i<gl->numIm; i++){
		k = gl->opt[i].yaw - 2;
		if( k >= 0 ) gl->im[i].yaw = gl->im[ k ].yaw;

		k = gl->opt[i].pitch - 2;
		if( k >= 0 ) gl->im[i].pitch = gl->im[ k ].pitch;

		k = gl->opt[i].roll - 2;
		if( k >= 0 ) gl->im[i].roll = gl->im[ k ].roll;

		k = gl->opt[i].hfov - 2;
		if( k >= 0 ) gl->im[i].hfov = gl->im[ k ].hfov;

		k = gl->opt[i].a - 2;
		if( k >= 0 ) gl->im[i].cP.radial_params[0][3] = gl->im[ k ].cP.radial_params[0][3];

		k = gl->opt[i].b - 2;
		if( k >= 0 ) gl->im[i].cP.radial_params[0][2] = gl->im[ k ].cP.radial_params[0][2];

		k = gl->opt[i].c - 2;
		if( k >= 0 ) gl->im[i].cP.radial_params[0][1] = gl->im[ k ].cP.radial_params[0][1];

		k = gl->opt[i].d - 2;
		if( k >= 0 ) gl->im[i].cP.horizontal_params[0] = gl->im[ k ].cP.horizontal_params[0];

		k = gl->opt[i].e - 2;
		if( k >= 0 ) gl->im[i].cP.vertical_params[0] = gl->im[ k ].cP.vertical_params[0];

		k = gl->opt[i].shear_x - 2;
		if( k >= 0 ) gl->im[i].cP.shear_x = gl->im[ k ].cP.shear_x;

		k = gl->opt[i].shear_y - 2;
		if( k >= 0 ) gl->im[i].cP.shear_y = gl->im[ k ].cP.shear_y;

		gl->im[i].cP.radial_params[0][0] = 1.0 - ( gl->im[i].cP.radial_params[0][3]
														+ gl->im[i].cP.radial_params[0][2]
														+ gl->im[i].cP.radial_params[0][1] ) ;

		SetEquColor( &(gl->im[i].cP) );

	}
	if ((line[sizeof(line)-1]!=0x5a)||(buf[sizeof(buf)-1]!=0x5a)) {
		ShowMessage("Internal error: at line "+AnsiString(__LINE__));
		Close();
		return -10;
	}
	MemoScript->Clear();
	/*if (!Fscript) {
		ShowMessage("Internal error: at line "+AnsiString(__LINE__));
	}*/
	delete [] Fscript;
	Fscript = 0;
	if (FLastResult < 0) {
		FLastResult = 0;
		return 1;
	} else {
		return FLastResult = 0;
	}
}
//---------------------------------------------------------------------------

TStrings*  TFormParser::PrintScript(PrintTarget target, GuiAlignInfo *g )
{
	char    line[MAX_LINE_LEN+2], cmd[MAX_LINE_LEN+2];
	int 	optHfov;		 // Has hfov being optimized?
	int	opta,optb,optc;  // same for a,b,c - the polynomial corrections
	int optd,opte,optg,optt;
	int linkHfov, linka,linkb,linkc;	// these can be linked
	int linkd, linke, linkg, linkt;
	int     format;
	int i,numIm;

	setlocale(LC_ALL, "C");
	line[sizeof(line)-1] = cmd[sizeof(cmd)-1] = 0x5a;

	// Current/last info packet is g
	Fgl = g;
	MemoScript->Clear();
	MemoScript->Lines->Add("# Output generated by PTOpenGui");
	switch (target) {
	case PRINT_PROJECT:
		MemoScript->Lines->Add("# project");
		break;
	case PRINT_OPTIMIZE:
		MemoScript->Lines->Add("# optimize");
		break;
	case PRINT_STITCH:
		MemoScript->Lines->Add("# stitch");
		break;
	default:
		MemoScript->Lines->Add("# anything/unknown");
		break;
	}
	//if( g->data != NULL )
	//	MemoScript->Lines->Add( (char*) g->data );
	// save project data
	if (target == PRINT_PROJECT) {
		// current directory is g->projDir
		if (g->projDir) {
			sprintf(line, "# Default directory %s",g->projDir);
			MemoScript->Lines->Add(line);
		}
		// Default output panorama name
		if (g->outPanoFile) {
		sprintf(line, "#-outPanoFile %s",g->outPanoFile);
		MemoScript->Lines->Add(line);
		}
		//gl->changeSingleImageLensData
		sprintf(line, "#-singleLensChange %d ", g->changeSingleImageLensData);
		MemoScript->Lines->Add(line);
		// scanner settings, scanResolution
		sprintf(line, "#-scanResolution %lf ", g->scanResolution);
		MemoScript->Lines->Add(line);
		// default lens setting style
		sprintf(line, "#-lensSettingStyle %d ", g->lensSettingStyle);
		MemoScript->Lines->Add(line);
		// default focal length
		sprintf(line, "#-lensFocalLength %lf ", g->lensFocalLength);
		MemoScript->Lines->Add(line);
		sprintf(line, "#-jpegquality %d ", g->jpegQ);
		MemoScript->Lines->Add(line);
		sprintf(line, "#-jpegprogressive %d ", g->jpegProgressive);
		MemoScript->Lines->Add(line);
		sprintf(line, "#-refImNr %d ", g->refImNr);
		MemoScript->Lines->Add(line);
	}


	MemoScript->Lines->Add("# Panorama description");
	switch( g->pano.format )
	{
		case _equirectangular:		format = 2; break;
		case _rectilinear:			format = 0; break;
		case _panorama:				format = 1; break;
		default:					format = g->pano.format; break;
	}
	// calculate reference image number
	int ref_k = (g->st.colcorrect/4)-1;
	int ref_b = g->pano.cP.radial_params[0][2];
	int ref_d = g->pano.cP.horizontal_params[0];
	int skip_cnt = 0;
	for (i=0; i<g->numIm; i++) {
		if (g->opt[i].stitch_fin == 0) {
			skip_cnt++;
		} else {
		}
		if (ref_k == i) {
			ref_k = i - skip_cnt;
			if (ref_k < 0) {
				ref_k = 0;
			}
		}
		if (ref_b == i) {
			ref_b = i - skip_cnt;
			if (ref_b < 0) {
				ref_b = 0;
			}
		}
		if (ref_d == i) {
			ref_d = i - skip_cnt;
			if (ref_d < 0) {
				ref_d = 0;
			}
		}
	}

	//u ja k
	sprintf( cmd, "p f%d w%ld h%ld v%f n\"%s\" ", format, g->pano.width, g->pano.height, g->pano.hfov, g->pano.name );
	//if (g->st.feather > 0)
	{
		sprintf(line, "u%d ", g->st.feather);
		strcat( cmd, line );
	}
	if (g->st.colcorrect > 0) {
		// bug when all images are not stitched
		sprintf(line, "k%d ", ref_k);
		strcat( cmd, line );
	} else
	if (g->pano.cP.radial) {
		//if b found -> brightness -> 1
		sprintf(line, "b%d ", ref_b);
		strcat( cmd, line );
	} else
	if (g->pano.cP.horizontal) {
		//if d found
		sprintf(line, "d%d ", ref_d);
		strcat( cmd, line );
	}
	MemoScript->Lines->Add(cmd);
	MemoScript->Lines->Add("");

	if (target != PRINT_OPTIMIZE) {
		MemoScript->Lines->Add("# Image modificators: i=interpolator g=gamma");
		if (g->sP.gamma <= 0.01) {
			g->sP.gamma = 1.0;	// set to default
		}
		sprintf(line, "m i%d g%f", g->sP.interpolator, g->sP.gamma);
		MemoScript->Lines->Add(line);
		MemoScript->Lines->Add("");
	}

	if (target == PRINT_PROJECT) {
		sprintf( line, "# Parameters for Each Input Image:" );
		MemoScript->Lines->Add(line);
		sprintf( line, "# (*) - optimized         (p) - preset ");
		MemoScript->Lines->Add(line); MemoScript->Lines->Add("");
	}

	numIm = g->numIm;
	for( i=0; i<g->numIm; i++ )
	{
		switch( g->im[i].format )
		{
			case _rectilinear 		: format = 0; break;
			case _panorama    		: format = 1; break;
			case _fisheye_circ		: format = 2; break;
			case _fisheye_ff  		: format = 3; break;
			case _equirectangular 	: format = 4; break;
			default: break;
		}
		// start reading of image data


		if (target == PRINT_STITCH) {
			// is there filename? dummy image from PTGui project
			if (!g->im[i].name || (g->im[i].name[0]==0)
			|| (g->opt[i].stitch_fin == 0) )
			{
				// continue from next image
				if (g->opt[i].stitch_fin == 0) {
					sprintf( line, "# image %d is skipped",i);
				} else {
					sprintf( line, "# no image name for image number: %d",i);
				}
				MemoScript->Lines->Add(line);
				MemoScript->Lines->Add("");
				continue;
			}
			// print filename
			sprintf( line, "i n\"%s\"",/*ExtractFileName*/(g->im[i].name));
			MemoScript->Lines->Add(line);
		}
		sprintf( cmd, "o f%d w%d h%d ", format, g->im[i].width, g->im[i].height);
		if (target == PRINT_OPTIMIZE) {
			// change image to input type
			cmd[0] = 'i';
		}

		// collect data of optmized values and linking
		// get linked and optimized values
		linkHfov = g->opt[i].hfov;
		if( linkHfov == 1 ||
			( linkHfov > 1 &&  g->opt[linkHfov-2].hfov == 1 ))
			optHfov = 1;
		else
			optHfov = 0;
		linka = g->opt[i].a;
		if( linka == 1 ||
			( linka > 1 &&  g->opt[linka-2].a == 1 ))
			opta = 1;
		else
			opta = 0;
		linkb = g->opt[i].b;
		if( linkb == 1 ||
			( linkb > 1 &&  g->opt[linkb-2].b == 1 ))
			optb = 1;
		else
			optb = 0;
		linkc = g->opt[i].c;
		if( linkc == 1 ||
			( linkc > 1 &&  g->opt[linkc-2].c == 1 ))
			optc = 1;
		else
			optc = 0;
		linkd = g->opt[i].d;
		if( linkd == 1 ||
			( linkd > 1 &&  g->opt[linkd-2].d == 1 ))
			optd = 1;
		else
			optd = 0;
		linke = g->opt[i].e;
		if( linke == 1 ||
			( linke > 1 &&  g->opt[linke-2].e == 1 ))
			opte = 1;
		else
			opte = 0;
		linkg = g->opt[i].shear_x;
		if( linkg == 1 ||
			( linkg > 1 &&  g->opt[linkg-2].shear_x == 1 ))
			optg = 1;
		else
			optg = 0;
		linkt = g->opt[i].shear_y;
		if( linkt == 1 ||
			( linkt > 1 &&  g->opt[linkt-2].shear_y == 1 ))
			optt = 1;
		else
			optt = 0;

		sprintf( line, "# Image No %d:", i); // , ((g->im[i].name != NULL) && (strlen( g->im[i].name) > 0) )?g->im[i].name:"-not-set-"
		if (target == PRINT_PROJECT) {
			MemoScript->Lines->Add(line);
		}
		sprintf( line, "# Yaw:	%f deg (%c)	Pitch:	%f deg (%c) ",
					g->im[i].yaw, ( g->opt[i].yaw ? '*' : 'p' ),
					g->im[i].pitch,  ( g->opt[i].pitch  ? '*' : 'p' ));
		if (target == PRINT_PROJECT) {
			MemoScript->Lines->Add(line);
		}
		sprintf( line, "# Roll:	%f deg (%c)	HFov:	%f deg (%c)",
					g->im[i].roll, ( g->opt[i].roll ? '*' : 'p' ),
					g->im[i].hfov,  (              optHfov  ? '*' : 'p' ));
		if (target == PRINT_PROJECT) {
			MemoScript->Lines->Add(line);
		}
		sprintf( line, "# Polynomial Coefficients: a   %f (%c); b   %f (%c); c   %f (%c)",
					g->im[i].cP.radial_params[0][3], (opta ? '*':'p'),
					g->im[i].cP.radial_params[0][2], (optb ? '*':'p'),
					g->im[i].cP.radial_params[0][1], (optc ? '*':'p'));
		if (target == PRINT_PROJECT) {
			MemoScript->Lines->Add(line);
		}
		sprintf( line, "# Horizontal Shift: %f (%c)   Vertical Shift:  %f (%c)",
					g->im[i].cP.horizontal_params[0], (optd ? '*':'p'),
					g->im[i].cP.vertical_params[0], (opte ? '*':'p')	);
		if (target == PRINT_PROJECT) {
			MemoScript->Lines->Add(line);
		}
		sprintf( line, "# Horizontal Shear: %f (%c)   Vertical Shear:  %f (%c)",
					g->im[i].cP.shear_x, (optg ? '*':'p'),
					g->im[i].cP.shear_y, (optt ? '*':'p')	);
		if (target == PRINT_PROJECT) {
			MemoScript->Lines->Add(line);
		}
		sprintf( line, "r%g p%g y%g ", g->im[i].roll,g->im[i].pitch,g->im[i].yaw);
		strcat( cmd, line );
		// is HFOV linked to some other image?
		if ((linkHfov <= 1)||(target == PRINT_STITCH)) {
			sprintf( line, "v%g ", g->im[i].hfov);
		} else {
			sprintf( line, "v=%d ", linkHfov-2);
		}
		strcat( cmd, line );
		//if( g->im[i].cP.radial )
		{
			if ((linka <= 1)||(target == PRINT_STITCH)) {
				sprintf( line, "a%f ", g->im[i].cP.radial_params[0][3]);
			} else {
				sprintf( line, "a=%d ", linka-2);
			}
			strcat( cmd, line );
			if ((linkb <= 1)||(target == PRINT_STITCH)) {
				sprintf( line, "b%f ", g->im[i].cP.radial_params[0][2]);
			} else {
				sprintf( line, "b=%d ", linkb-2);
			}
			strcat( cmd, line );
			if ((linkc <= 1)||(target == PRINT_STITCH)) {
				sprintf( line, "c%f ", g->im[i].cP.radial_params[0][1]);
			} else {
				sprintf( line, "c=%d ", linkc-2);
			}
			strcat( cmd, line );
		}
		if( g->im[i].cP.cutFrame &&
		 !( g->im[i].selection.bottom != 0 || g->im[i].selection.right != 0 )) // g->im[i].format != _fisheye_circ && g->im[i].cP.cutFrame )
		{
			if( g->im[i].cP.frame != 0 )
			{
				sprintf( line, "m%ld ",g->im[i].cP.frame );
			}
			else
			{
				sprintf( line, "mx%ld my%d ",g->im[i].cP.fwidth, g->im[i].cP.fheight );
			}
			strcat( cmd, line );
		}

//		sprintf( line, "d%f e%f ", g->prefs[i]->c_prefs.horizontal_params[0], g->prefs[i]->c_prefs.vertical_params[0]);
//		strcat( cmd, line );
#if 0
		if( g->prefs[i]->colCorrect )
		{
			sprintf( line, "t%f,%f,%f,%f,%f,%f ", g->prefs[i]->ColCoeff[0][0],
														g->prefs[i]->ColCoeff[0][1],
														g->prefs[i]->ColCoeff[1][0],
														g->prefs[i]->ColCoeff[1][1],
														g->prefs[i]->ColCoeff[2][0],
														g->prefs[i]->ColCoeff[2][1]);
			strcat( cmd, line );
		}
#endif
		//if( g->im[i].cP.horizontal || (linkd>1))
		{
			if ((linkd <= 1)||(target == PRINT_STITCH)) {
				sprintf( line, "d%f ", g->im[i].cP.horizontal_params[0]);
			} else {
				sprintf( line, "d=%d ", linkd-2);
			}
			//sprintf( line, "d%f ",g->im[i].cP.horizontal_params[0]);
			strcat( cmd, line );
		}
		//if( g->im[i].cP.vertical ||(linke>1))
		{
			if ((linke <= 1)||(target == PRINT_STITCH)) {
				sprintf( line, "e%f ", g->im[i].cP.vertical_params[0]);
			} else {
				sprintf( line, "e=%d ", linke-2);
			}
			//sprintf( line, "e%f ",g->im[i].cP.vertical_params[0]);
			strcat( cmd, line );
		}
		//if( g->im[i].cP.shear ||(linkg>1)||(linkt>1))
		{
			if ((linkg <= 1)||(target == PRINT_STITCH)) {
				sprintf( line, "g%f ", g->im[i].cP.shear_x);
			} else {
				sprintf( line, "g=%d ", linkg-2);
			}
			strcat( cmd, line );
			if ((linkt <= 1)||(target == PRINT_STITCH)) {
				sprintf( line, "t%f ", g->im[i].cP.shear_y);
			} else {
				sprintf( line, "t=%d ", linkt-2);
			}
			strcat( cmd, line );
		}
		if( g->im[i].cP.correction_mode & correction_mode_morph )
		{
			strcat( cmd, "o " );
		}
		if( g->im[i].selection.bottom != 0 || g->im[i].selection.right != 0 ){
			if( g->im[i].cP.cutFrame ){
				sprintf( line, " C%d,%d,%d,%d ",g->im[i].selection.left, g->im[i].selection.right,
							   g->im[i].selection.top, g->im[i].selection.bottom );
			}else{
				sprintf( line, " S%d,%d,%d,%d ",g->im[i].selection.left, g->im[i].selection.right,
							   g->im[i].selection.top, g->im[i].selection.bottom );
			}
			strcat( cmd, line );
		}
#if 0
		// Print filename
		if( (g->im[i].name != NULL) && (strlen( g->im[i].name) > 0) ){
			sprintf(line, " n\"%s\" ", g->im[i].name);
			strcat( cmd, line );
		}

#endif
		if (target == PRINT_STITCH) {
		// Add command for stitcher, depending on g->st
		// If '-' option has been set (destName != 0), do nothing
		// else add stitch commands
		if( !g->st.destName ) {
			if( i== 0 )			{
				if (g->st.srcName) {
					sprintf(line, "-%s ", g->st.srcName);
					strcat( cmd, line );
				}
			}
			else if( i == g->numIm-1 )	{
				if (g->st.srcName) {
				sprintf(line, "+%s ", g->st.srcName);
				strcat( cmd, line );
				}
			} else {
				if (g->st.srcName) {
				sprintf(line, "+%s -%s ", g->st.srcName, g->st.srcName);
				strcat( cmd, line );
				}
			}
		}
		}

		if (target == PRINT_PROJECT) {
			if( opta || optb || optc )
			{
				sprintf(line,"# 4th polynomial coefficient: %g", 1.0 - ( g->im[i].cP.radial_params[0][3]
																 + g->im[i].cP.radial_params[0][2]
																 + g->im[i].cP.radial_params[0][1] ) );
				MemoScript->Lines->Add(line);//strcat( res, line );
			}
		}
		if (target == PRINT_PROJECT) {
			// Print filename
			if( (g->im[i].name != NULL) && (strlen( g->im[i].name) > 0) ){
				AnsiString fname,projDir;
				fname = g->im[i].name;
				projDir = g->projDir;
				if (projDir.Length() > 1) {
					if (projDir == ExtractFilePath(fname)) {
						fname = ExtractFileName(fname);
					}
				}
				// write if image is optimized
				sprintf(line, "#-imgoptcp %d",g->opt[i].use);
				MemoScript->Lines->Add(line);
				int angle = g->im[i].angle;
				while (angle <= -360) {
					angle += 360;
				}
				while (angle >= 360) {
					angle -= 360;
				}
				sprintf(line, "#-imgrotate %d",angle);
				MemoScript->Lines->Add(line);
				// write #-imgfile <width> <height> <filename>
				sprintf(line, "#-imgfile %d %d \"%s\"",
				g->im[i].width, g->im[i].height, fname.c_str());
				MemoScript->Lines->Add(line);
			}
		}
		if (target == PRINT_STITCH) {
			//MemoScript->Lines->Add("# Command for Panorama Creation:");
		}
		MemoScript->Lines->Add( cmd );
		MemoScript->Lines->Add("");
	} // numIm

	if (target == PRINT_PROJECT) {
		MemoScript->Lines->Add("");
		MemoScript->Lines->Add("# Optimization parameters");
	}
/*
		int hfov;		//  optimize hfov? 0-no 1-yes, 2-same as index 0, 3-same as index 1, ...
		int yaw;		int pitch;		int roll;
		int a;		int b;		int c;
		int d;		int e;
*/
	if (target != PRINT_STITCH)
	for( i=0; i<g->numIm; i++ ) {
		if (target == PRINT_OPTIMIZE) {
			if (g->opt[i].use == 0) {
				continue;	// nothing to optimize NOW
			}
		}
		// print one line for every image if any parameters are optimized
		line[0] = 0;
		sprintf( cmd, "v ");
		//
		if (g->opt[i].hfov == 1) {
			// 1: opt this alone
			// >1: link this with n-2
			sprintf(line,"v%d ",i);			strcat( cmd, line );
		}
		if (g->opt[i].yaw == 1) {
			sprintf(line,"y%d ",i);			strcat( cmd, line );
		}
		if (g->opt[i].pitch == 1) {
			sprintf(line,"p%d ",i);			strcat( cmd, line );
		}
		if (g->opt[i].roll == 1) {
			sprintf(line,"r%d ",i);			strcat( cmd, line );
		}
		if (g->opt[i].a == 1) {
			sprintf(line,"a%d ",i);			strcat( cmd, line );
		}
		if (g->opt[i].b == 1) {
			sprintf(line,"b%d ",i);			strcat( cmd, line );
		}
		if (g->opt[i].c == 1) {
			sprintf(line,"c%d ",i);			strcat( cmd, line );
		}
		if (g->opt[i].d == 1) {
			sprintf(line,"d%d ",i);			strcat( cmd, line );
		}
		if (g->opt[i].e == 1) {
			sprintf(line,"e%d ",i);			strcat( cmd, line );
		}
		if (g->opt[i].shear_x == 1) {
			sprintf(line,"g%d ",i);			strcat( cmd, line );
		}
		if (g->opt[i].shear_y == 1) {
			sprintf(line,"t%d ",i);			strcat( cmd, line );
		}
		if (line[0] != 0) {
			MemoScript->Lines->Add(cmd);
		}
	}
	if (target != PRINT_STITCH)
	if( g->numPts > 0 ) // Display Controlpoint distances
	{
		MemoScript->Lines->Add("");
		MemoScript->Lines->Add("# ====================================================================");
		MemoScript->Lines->Add("# Control Points: Distance between desired and fitted Position (in Pixels)");
		MemoScript->Lines->Add("");

		for( i=0; i<g->numPts; i++ )
		{
			int t,imNr;
			t = g->cpt[i].type;
			if (g->cpt[i].comment) {
				sprintf( line, "#! %s",g->cpt[i].comment);
				if (t < 0) {
					// not active control point
					line[1] = '*';	// not a proper comment line anymore
				}
				MemoScript->Lines->Add(line);
			}
			sprintf( line, "c n%d N%d x%g y%g X%g Y%g t%d",
				g->cpt[i].num[0], g->cpt[i].num[1],
				g->cpt[i].x[0], g->cpt[i].y[0],
				g->cpt[i].x[1], g->cpt[i].y[1],
				g->cpt[i].type);
			// test if control point is not deleted and type is valid
			if ((t == -1)
			||(g->cpt[i].num[0] >= numIm)
			||(g->cpt[i].num[1] >= numIm)
			||(g->cpt[i].num[0] < 0)
			||(g->cpt[i].num[1] < 0)) {
				// deleted type
				line[0] = '#';  // comment this line
			} else {
				// proper numbers
				if (target == PRINT_OPTIMIZE) {
					imNr = g->cpt[i].num[0];
					if (g->opt[imNr].use == 0) {
						line[0] = '#';
					}
					imNr = g->cpt[i].num[1];
					if (g->opt[imNr].use == 0) {
						line[0] = '#';
					}
				}
			}
			if ((t<-1)||(t>MAX_CP_TYPE_VALUE)) {	// min and max for 't'
				sprintf( cmd, "#error: ");
				strcat( cmd, line );
				MemoScript->Lines->Add(cmd);
			} else {
				MemoScript->Lines->Add(line);
			}
			sprintf( line, "# Control Point No %d:  %g", i , g->cpt[i].ds );//sqrt ( ds(i)) );
			if (target == PRINT_OPTIMIZE) {
				// do not print text in same format
				line[1] = '+';
			}
			MemoScript->Lines->Add(line);//strcat( res, line );
		}
#if 0
		// Print optimum positions for points in panorama
		for( i=0; i<g->numPts; i++ )
		{
			double x[2],y[2],xd,yd;

			if(g->cpt[i].num[0] != g->cpt[i].num[1])
			{
				GetControlPointCoordinates(i, x, y, g );
				// Write only points inside image
				if( x[0] >= 0.0 && x[0] < g->pano.width && x[1] >= 0.0 && x[1] < g->pano.width &&
					y[0] >= 0.0 && y[0] < g->pano.height && y[1] >= 0.0 && y[1] < g->pano.height)
				{
					xd = (x[0]+x[1]) / 2.0;
					yd = (y[0]+y[1]) / 2.0;
					sprintf( line, "C i%d  x%g y%g X%g Y%g\n", g->cpt[i].num[0] , x[0], y[0], xd, yd );
										MemoScript->Lines->Add(line);//strcat( res, line );
					sprintf( line, "C i%d  x%g y%g X%g Y%g\n", g->cpt[i].num[1] , x[1], y[1], xd, yd );
										MemoScript->Lines->Add(line);//strcat( res, line );
				}
			}
		}
#endif
	}
	if ((line[sizeof(line)-1]!=0x5a)||(cmd[sizeof(cmd)-1]!=0x5a)) {
		ShowMessage("internal error!!!");
		Close();
		MemoScript->Lines->Clear();
	}
	return MemoScript->Lines;
}

char * TFormParser::ReadLastScript(void)
{
	return MemoScript->Text.c_str();
}

void  TFormParser::readControlPoints(char* script, GuiControlPoint *cp )
{
	struct GuiControlPoint defCn;

	// Variables used by parser

	char 				line[256], *ch ,*lineStart;
	int 				lineNum = 0;
	int 				i;
	int 				numPts;
	//int 				n=0; // Number of parameters to optimize

	setlocale(LC_ALL, "C");

	defCn.num[0] 	= 	defCn.num[1] = -1;
	defCn.type		=	0;
	defCn.x[0] 	= 	defCn.x[1] = 	defCn.y[0] 	= 	defCn.y[1] = 0;

	for(i=0; i< NUMPTS; i++)
		memcpy( &(cp[i]), &defCn, sizeof( GuiControlPoint ) );

	numPts = 0; // reused as indices

	// Parse script
	ch = script;
	while( *ch != 0 )
	{
		lineNum++;
		while(*ch == '\n')
			ch++;
		lineStart = ch;

		// read a line of text into line[];
		nextLine( line, &ch );

		// parse line; use only if first character is c
		switch( line[0] )
		{
			case 'c':		// Control Points
				defCn.num[0] 	= 	defCn.num[1] = -1;
				defCn.type		=	0;
				defCn.x[0] 	= 	defCn.x[1] = 	defCn.y[0] 	= 	defCn.y[1] = 0;

				if( ReadControlPoint( &defCn, &(line[1]) ) != 0 )
				{
					PrintError("Error in line %d", lineNum);
					return;
				}
				if( defCn.num[1] == -1 ) 	// We found a partial controlpoint
				{
					*lineStart = 0; 		// script ends here
					memcpy( &(cp[numPts]), &defCn, sizeof( GuiControlPoint ) );
					numPts++;
				}
				break;
			case '*':	// End of script-data
				*lineStart = 0; *ch = 0;
				break;
			default:
				break;
		}
	}
}

// Fill 'word' with word starting at (*ch). Advance *ch

void  TFormParser::nextWord( register char* word, char** ch )
{
	register char *c;
	c = *ch;

	c++;
	if( *c == '\"' )	{
		c++;
		while( *c != '\"' && *c != 0 )
			*word++ = *c++;
	} else {
		// show data of
		//if (_chartype[*c+1])
		while( !isspace(*c) && *c != 0 )
		{
			*word++ = *c++;
		}
	}
	*word = 0;
	*ch  = c;
}

// Fill 'line' with line starting at (*ch). Advance *ch

void  TFormParser::nextLine( register char* line, char** ch )
{
	register char *c;
	register int i;

	c = *ch;
	while(*c == '\n')
		c++;
	// read a line of text into line[];
	i=0;
	while( *c != 0 && *c != '\n' && i++<MAX_LINE_LEN)
		*line++ = *c++;
	*line = 0;
	*ch = c;
}

// Number of lines in script starting with character 'first'

int  TFormParser::numLines( char* script, char first )
{
	register char *ch;
	int result = 0;

	ch = script;
	while( *ch != 0 )
	{
		// Advance to linestart
		while(*ch == '\n')
			ch++;
		if( *ch == first )
			result++;
		while(*ch != '\n' && *ch != 0)
			ch++;
	}
	return result;
}

#undef  MY_SSCANF
#define MY_SSCANF( str, format, ptr )		if( sscanf( str, format, ptr ) != 1 )   \
												return -1;							\

#undef READ_VAR
#define READ_VAR(format, ptr )		nextWord( buf, &ch );			\
									MY_SSCANF( buf, format, ptr );


// Parse a line describing a single Controlpoint

int  TFormParser::ReadControlPoint( GuiControlPoint * cptr, char *line)
{
	GuiControlPoint		cp;
	char *ch	= line;
	bool setn, setN, setx, setX, sety, setY;
	char buf[256];


	setn = setN = setx= setX = sety = setY = false;

	memcpy(  &cp, cptr, sizeof(GuiControlPoint) );

	while( *ch != 0)
	{
		switch(*ch)
		{
			case 't':	READ_VAR("%ld", &(cp.type));
						break;
			case 'n':	READ_VAR("%ld", &(cp.num[0]));
						setn = true;
						break;
			case 'N':	READ_VAR("%ld", &(cp.num[1]));
						setN = true;
						break;
			case 'x':	READ_VAR("%lf", &(cp.x[0]));
						setx = true;
						break;
			case 'X':	READ_VAR("%lf", &(cp.x[1]));
						setX = true;
						break;
			case 'y':	READ_VAR("%lf", &(cp.y[0]));
						sety = true;
						break;
			case 'Y':	READ_VAR("%lf", &(cp.y[1]));
						setY = true;
						break;
			case 'i':	READ_VAR("%ld", &(cp.num[0]));
						cp.num[1] = cp.num[0];
						setn = true;
						setN = true;
			default: 	ch++;
						break;
		}
	}

	// Check values
	
	if( setn	== false || setN	== false || setx == false || setX == false ||
		sety	== false || setY 	== false )
	{
			PrintError("Missing Control Point Parameter");
			return -1;
	}
	else if( (cp.type < 0) ||(cp.type > MAX_CP_TYPE_VALUE) )	// change by JuHe 
	{
			PrintError("Control Point Type must be 0,1,2 or 3");
			return -1;
	}
	else if( cp.x[0] < 0 || cp.y[0] < 0 || cp.x[1] < 0 || cp.y[1] < 0)
	{
			PrintError("Pixel Coordinates must be positive");
			return -1;
	}
	else // looks ok so far
	{
		memcpy( cptr, &cp, sizeof(GuiControlPoint) );
		return 0;
	}
}


// Parse a line describing a single image

int  TFormParser::ReadImageDescription( GuiImage *imPtr, stBuf *sPtr, char *line )
{
	GuiImage im;
	stBuf sBuf;
	char *ch = line;
	char buf[256];
	int	 i;


	memcpy( &im, 	imPtr,	 sizeof(GuiImage) );
	memcpy( &sBuf, 	sPtr,	 sizeof(stBuf ));

	while( *ch != 0)
	{
		switch(*ch)
		{
			case 'v':	READ_VAR( "%lf", &im.hfov );
						break;
			case 'a':	READ_VAR( "%lf", &(im.cP.radial_params[0][3]));
						im.cP.radial 	= TRUE;
						break;
			case 'b':	READ_VAR("%lf", &(im.cP.radial_params[0][2]));
						im.cP.radial 	= TRUE;
						break;
			case 'c':	READ_VAR("%lf", &(im.cP.radial_params[0][1]));
						im.cP.radial	= TRUE;
						break;
			case 'f':	READ_VAR( "%d", &im.format );
						if( im.format == _panorama || im.format == _equirectangular )
							im.cP.correction_mode |= correction_mode_vertical;
						break;
			case 'y':	READ_VAR( "%lf", &im.yaw);
						break;
			case 'p':	READ_VAR( "%lf", &im.pitch);
						break;
			case 'r':	READ_VAR( "%lf", &im.roll);
						break;
			case 'd':	READ_VAR("%lf", &(im.cP.horizontal_params[0]));
						im.cP.horizontal 	= TRUE;
						break;
			case 'e':	READ_VAR("%lf", &(im.cP.vertical_params[0]));
						im.cP.vertical = TRUE;
						break;
			case 'g':	READ_VAR("%lf", &(im.cP.shear_x));
						im.cP.shear 	= TRUE;
						break;
			case 't':	READ_VAR("%lf", &(im.cP.shear_y));
						im.cP.shear = TRUE;
						break;
			case '+':	nextWord( buf, &ch );
						//sprintf( sBuf.srcName, "%s", buf);
						sBuf.srcName = AllocString(buf,sBuf.srcName);
						break;
			case '-':	nextWord( buf, &ch );
						//sprintf( sBuf.destName, "%s", buf );
						sBuf.destName = AllocString(buf,sBuf.destName);
						break;
			case 'u':	READ_VAR( "%d", &(sBuf.feather) );
						break;
			case 's':	READ_VAR( "%d", &sBuf.seam );
						{
							if(sBuf.seam != _dest)
								sBuf.seam = _middle;
						}
						break;
			case 'w':	READ_VAR( "%d", &im.width );
						break;
			case 'h':	READ_VAR("%d", &im.height);
						break;
			case 'o':	ch++;
						im.cP.correction_mode |= correction_mode_morph;
						break;
			case 'k':  // Colour correction
						READ_VAR( "%d", &i );
						// i &= 3;
						sBuf.colcorrect = i&3;		// was |=
						sBuf.colcorrect += (i+1)*4;
						break;
			case 'm':  // Frame
						ch++;
						switch( *ch )
						{
							case 'x':
								READ_VAR( "%d", &im.cP.fwidth );
								im.cP.cutFrame = TRUE;
								break;
							case 'y':
								READ_VAR( "%d", &im.cP.fheight );
								im.cP.cutFrame = TRUE;
								break;
							default:
								ch--;
								READ_VAR( "%d", &(im.cP.frame) );
								im.cP.cutFrame = TRUE;
								break;
						}
						break;
			case 'n':  // Name string (used for panorama format)
						nextWord( buf, &ch );
						//strcpy( im.name, buf );
						im.name = AllocString(buf,0);
						break;
			case 'S':  nextWord( buf, &ch );
				   sscanf( buf, "%d,%d,%d,%d", &im.selection.left, &im.selection.right, &im.selection.top, &im.selection.bottom );
				   break;
			case 'C':  nextWord( buf, &ch );
				   sscanf( buf, "%d,%d,%d,%d", &im.selection.left, &im.selection.right, &im.selection.top, &im.selection.bottom );
				   im.cP.cutFrame = TRUE;
				   break;
			default: 	ch++;
						break;
		}
	}

	// Set 4th polynomial parameter

	im.cP.radial_params[0][0] = 1.0 - ( im.cP.radial_params[0][3] + im.cP.radial_params[0][2]
																  + im.cP.radial_params[0][1] ) ;

	SetEquColor( &im.cP );
	SetCorrectionRadius( &im.cP );
	// Do checks

	// appears ok

	memcpy( imPtr,	&im, sizeof(GuiImage) );
	memcpy( sPtr,	&sBuf, sizeof(stBuf ) );
	return 0;
}

// Parse a line describing modes

int  TFormParser::ReadModeDescription( sPrefs *sP, char *line )
{
	sPrefs theSprefs;
	char *ch = line;
	char buf[256];

	setlocale(LC_ALL, "C");
	memcpy( &theSprefs, 	sP,	 sizeof(sPrefs) );

	while( *ch != 0)
	{
		switch(*ch)
		{
			case 'g':	READ_VAR( "%lf", &theSprefs.gamma );
						if( theSprefs.gamma <= 0.0 )
							return -1;
						break;
			case 'i':	READ_VAR( "%d", &theSprefs.interpolator );
						if( theSprefs.interpolator < 0 ||  theSprefs.interpolator > 7 )
							theSprefs.interpolator = 0;
						break;
			case 'p':	READ_VAR( "%d", &theSprefs.optCreatePano );
						if(theSprefs.optCreatePano != 0)
							theSprefs.optCreatePano = TRUE;
						break;
			default: 	ch++;
						break;
		}
	}
	
	// appears ok
	
	memcpy( sP,	 &theSprefs, 	sizeof(sPrefs) );
	return 0;
}

// Parse a string desscribing VRPanoOptions

int	 TFormParser::getVRPanoOptions( VRPanoOptions *v, char *line )
{
	char 			*ch = line;
	char 			buf[256];
	VRPanoOptions 	VRopt;

	setlocale(LC_ALL, "C");
	memcpy( &VRopt, v, sizeof( VRPanoOptions ) );
		
	while( *ch != 0)
	{
		switch(*ch)
		{
			case 'w':	READ_VAR("%d", &VRopt.width); 
						break;
			case 'h':	READ_VAR("%d", &VRopt.height);
						break;
			case 'p':	READ_VAR("%lf", &VRopt.pan);
						break;
			case 't':	READ_VAR("%lf", &VRopt.tilt);
						break;
			case 'v':	READ_VAR("%lf", &VRopt.fov);
						break;
			case 'c':	READ_VAR("%d", &VRopt.codec);
						break;
			case 'q':	READ_VAR("%ld", &VRopt.cquality);
						break;
			case 'g':	READ_VAR("%ld", &VRopt.progressive);
						break;
			default: 	ch++;
						break;
		}
	}
	memcpy( v, &VRopt, sizeof( VRPanoOptions ) );
	return 0;
}



// Read coordinates of positions

int  TFormParser::readPositions( char* script, transformCoord *tP )
{
	// Variables used by parser

	char 			    line[256], *ch ;
	int 				lineNum = 0;
	int 				nr=0,np=0;


	setlocale(LC_ALL, "C");
	// Determine number of images and control points


	tP->nump 	= numLines( script, 'P' );
	tP->numr 	= numLines( script, 'R' );

	// Allocate Space for Pointers to images, preferences and control points

	//tP->r 		= (CoordInfo*)		malloc( tP->numr 	* sizeof(CoordInfo) );
	//tP->p		= (CoordInfo*)		malloc( tP->nump 	* sizeof(CoordInfo) );
	tP->r 		= new CoordInfo[tP->numr];
	tP->p		= new CoordInfo[tP->nump];

	if( tP->r == NULL || tP->p == NULL )
	{
		PrintError("Not enough memory");
		return -1;
	}


	// Parse script

	ch = script;

	while( *ch != 0 )
	{
		lineNum++;

		while(*ch == '\n')
			ch++;

		// read a line of text into line[];

		nextLine( line, &ch );
		// parse line; use only if first character is p,o,m

		switch( line[0] )
		{
		case 'P':	// Coordinates as is
					if( ReadCoordinates( &tP->p[np++], &(line[1]) ) != 0 )
					{
						PrintError( "Syntax error in line %d" , lineNum);
						//mem_free( script );
						return -1;
					}
					break;
		case 'R':	// Coordinate values requested
					if( ReadCoordinates( &tP->r[nr++], &(line[1]) ) != 0 )
					{
						PrintError( "Syntax error in line %d" , lineNum);
						//mem_free( script );
						return -1;
					}
					break;
		 default: break;
		}
	}
	return 0;
}


int  TFormParser::ReadCoordinates( 	CoordInfo	*cp, char *line )
{
	CoordInfo	ci;
	char *ch = line;
	char buf[256];

	ci.num = ci.set[0] = ci.set[1] = ci.set[2] = 0;
	ci.x[0] = ci.x[1] = ci.x[2] = 1.0;


	while( *ch != 0)
	{
		switch(*ch)
		{
			case 'c':	READ_VAR( "%d", &ci.num );
						break;
			case 'i':	READ_VAR( "%d", &ci.num );
						ci.num -= 2;
						break;
			case 'X':	READ_VAR( "%lf", &ci.x[0] );
						ci.set[0] = TRUE;
						break;
			case 'Y':	READ_VAR( "%lf", &ci.x[1] );
						ci.set[1] = TRUE;
						break;
			case 'Z':	READ_VAR( "%lf", &ci.x[2] );
						ci.set[2] = TRUE;
						break;
			default: 	ch++;
						break;
		}
	}

	// appears ok

	memcpy( cp,	 &ci, 	sizeof(CoordInfo) );
	return 0;
}

int  TFormParser::ReadMorphPoints( char *script, GuiAlignInfo *gl, int nIm )
{
	// Variables used by parser

	char 			    line[256], *ch ;
	int 				lineNum = 0;
	int					np = 0;
	GuiControlPoint		cp;
	void 				*tmp;


	setlocale(LC_ALL, "C");

	// Determine number of morph control points


	gl->numPts 	= numLines( script, 'C' );
	if( gl->numPts == 0 )
		return 0;

	// Allocate Space for Pointers to images, preferences and control points

	//gl->cpt 	= (GuiControlPoint*)	malloc( gl->numPts 	* sizeof(GuiControlPoint) );
	gl->cpt 	= new GuiControlPoint[gl->numPts];

	if( gl->cpt == NULL )
	{
		PrintError("Not enough memory");
		return -1;
	}


	// Parse script

	ch = script;

	while( *ch != 0 )
	{
		lineNum++;

		while(*ch == '\n')
			ch++;

		// read a line of text into line[];

		nextLine( line, &ch );
		// parse line; use only if first character is p,o,m

		switch( line[0] )
		{
		case 'C':	// Coordinates as is
					cp.type = 0;
					if(  ReadControlPoint( &cp, &(line[1]) ) != 0 )
					{
						PrintError( "Syntax error in line %d" , lineNum);
						//mem_free( script );
						return -1;
					}
					if( cp.num[0] == nIm )
					{
						cp.num[0] = 0;
						cp.num[1] = 1;
						memcpy( &gl->cpt[np], &cp, sizeof( GuiControlPoint ));
						np++;
					}
		 default: break;
		}
	}


	//tmp =  realloc( gl->cpt, np * sizeof( GuiControlPoint ) );
	tmp =  ResizeMem( gl->cpt, np * sizeof( GuiControlPoint ),gl->numPts*sizeof( GuiControlPoint ));
	if( tmp == NULL )
		return -1;
	gl->numPts=np;
	gl->cpt = (GuiControlPoint*)tmp;

	return np;
}

void  TFormParser::SetCoordDefaults( CoordInfo *c, int num )
{
		c->num	= num;
		c->x[0] = (double) num;
		c->x[1] = c->x[2] = 0.0;
		c->set[0] = c->set[1] = c->set[2] = TRUE;
}

//----------------------------------------------------------------
/*void   TFormParser::PrintError(AnsiString str)
{
        //FormParser->ShowModal();
        FormParser->Show();
        //ShowMessage(str);
        MemoErrors->Lines->Add(str);
}*/

void   TFormParser::PrintError( char* str, bool showScript)
{
		//FormParser->Show();
        //ShowMessage(str);
        MemoErrors->Lines->Add(str);
        if (showScript) {
                if (FLastResult == 0)
                        FLastResult = -1;
                if (!FormParser->Visible)
						FormParser->ShowModal();
        }
}

void   TFormParser::PrintError( char* str, int num, bool showScript)
{
        char line[1024];
		sprintf(line,str,num);
        //AnsiString as;
        //as = line;
        MemoErrors->Lines->Add(line);
        //ShowMessage(line);
		if (showScript) {
				if (FLastResult == 0)
						FLastResult = -1;
				if (!FormParser->Visible)
						FormParser->ShowModal();
		}
}

//------------------------------------------------------------
void  TFormParser::ButtonCloseClick(TObject *Sender)
{
		Close();
}
//---------------------------------------------------------------------------

void  TFormParser::ButtonRereadClick(TObject *Sender)
{
	//if (ParseScript(MemoScript->Text.c_str(),MemoScript->Lines->Text.Length(), Fgl,false,false) >= 0) {
	if (ParseScript(MemoScript->Lines, Fgl,false,false) >= 0) {
		// result is OK
		ButtonCloseClick(0);
	}
}
//---------------------------------------------------------------------------

void  TFormParser::FormCreate(TObject *Sender)
{
	//
	Fgl = 0;
	FLastResult = 0;
	Tag = 1;
	Fscript = 0;
	Fscript_len = 0;
}
//---------------------------------------------------------------------------

bool  TFormParser::CopyOptimizedData(GuiAlignInfo *to_g, GuiAlignInfo *from_g, bool bg_process,bool OptimizationResult)
{
	int i,j;
	if (bg_process) {
		i = to_g->numPts;
		if (i<from_g->numPts)
			AddControlPoint2AlignInfo(to_g,from_g->numPts-i);
	} else
	// test that image and control point count is same
	if (!bg_process &&((to_g->numIm != from_g->numIm)||(to_g->numPts < from_g->numPts))) {
		ShowMessage("Unknown error: \n"
		"optimized result do not have same image \n"
		"and control point count!");
		return false;
	}
	// copies y,p,r,a,b,c,d,e and control point ds
	for (i=0; i<to_g->numIm&&i<from_g->numIm; i++) {
		to_g->im[i].yaw = from_g->im[i].yaw;
		to_g->im[i].pitch = from_g->im[i].pitch;
		to_g->im[i].roll = from_g->im[i].roll;
		to_g->im[i].hfov = from_g->im[i].hfov;
		//
		to_g->im[i].cP.radial_params[0][1] = from_g->im[i].cP.radial_params[0][1];//c
		to_g->im[i].cP.radial_params[0][2] = from_g->im[i].cP.radial_params[0][2];//b
		to_g->im[i].cP.radial_params[0][3] = from_g->im[i].cP.radial_params[0][3];//a
		// horizontal_params
		to_g->im[i].cP.horizontal_params[0] = from_g->im[i].cP.horizontal_params[0];//d
		to_g->im[i].cP.vertical_params[0] = from_g->im[i].cP.vertical_params[0];//e
		to_g->im[i].cP.shear_x = from_g->im[i].cP.shear_x;//d
		to_g->im[i].cP.shear_y = from_g->im[i].cP.shear_y;//e
	}
	if (OptimizationResult) {
		for (i=0,j=0; (i<from_g->numPts)&&(j<to_g->numPts); i++,j++) {
			// skip deleted or not used control points
//int imNr0, imNr1;
//imNr0 = to_g->cpt[j].num[0];	//remove
//imNr1 = to_g->cpt[j].num[1];
			while ((to_g->cpt[j].type < 0)
			||(to_g->opt[to_g->cpt[j].num[0]].use == 0)
			||(to_g->opt[to_g->cpt[j].num[1]].use == 0))
			{
				j++;
//imNr0 = to_g->cpt[j].num[0];
// imNr1 = to_g->cpt[j].num[1];
				// test if there is deleted more than there were before optimization start
				if (j>=to_g->numPts) {
					return true;
				}
			}
			to_g->cpt[j].ds = from_g->cpt[i].ds;
		}
	} else {
		for (i=0; i<to_g->numPts; i++) {
			to_g->cpt[i].ds = from_g->cpt[i].ds;
			to_g->cpt[i].type = from_g->cpt[i].type;
			for (j=0; j<2; j++) {
				to_g->cpt[i].num[j] = from_g->cpt[i].num[j];
				to_g->cpt[i].x[j] = from_g->cpt[i].x[j];
				to_g->cpt[i].y[j] = from_g->cpt[i].y[j];
			}
		}
		to_g->pano.width = from_g->pano.width;
		to_g->pano.height = from_g->pano.height;
		to_g->pano.name = AllocString(from_g->pano.name,to_g->pano.name);
	}
	return true;
}
bool  TFormParser::CopyImageStitchData(GuiAlignInfo *to_g, GuiAlignInfo *from_g, bool bg_process)
{
	int i;
	// add image count to at least same leves as source has
	while (to_g->numIm < from_g->numIm) {
		AddImage2AlignInfo(to_g);
	}
	to_g->pano.width = from_g->pano.width;
	to_g->pano.height = from_g->pano.height;
	to_g->pano.name = AllocString(from_g->pano.name,to_g->pano.name);
	to_g->pano.hfov = from_g->pano.hfov;
	to_g->pano.format = from_g->pano.format;
	to_g->st.feather = from_g->st.feather;
	to_g->sP.gamma = from_g->sP.gamma;
	to_g->sP.interpolator = from_g->sP.interpolator;
	to_g->st.colcorrect = from_g->st.colcorrect;
	for (i=0; i<from_g->numIm; i++) {
		to_g->opt[i].use = from_g->opt[i].use;
		to_g->opt[i].stitch_pre = from_g->opt[i].stitch_pre;
		to_g->opt[i].stitch_fin = from_g->opt[i].stitch_fin;
		to_g->im[i].width = from_g->im[i].width;
		to_g->im[i].height = from_g->im[i].height;
		to_g->im[i].format = from_g->im[i].format;
		to_g->im[i].yaw = from_g->im[i].yaw;
		to_g->im[i].pitch = from_g->im[i].pitch;
		to_g->im[i].roll = from_g->im[i].roll;
		to_g->im[i].hfov = from_g->im[i].hfov;
		//
		to_g->im[i].cP.radial_params[0][1] = from_g->im[i].cP.radial_params[0][1];//c
		to_g->im[i].cP.radial_params[0][2] = from_g->im[i].cP.radial_params[0][2];//b
		to_g->im[i].cP.radial_params[0][3] = from_g->im[i].cP.radial_params[0][3];//a
		// horizontal_params
		to_g->im[i].cP.horizontal_params[0] = from_g->im[i].cP.horizontal_params[0];//d
		to_g->im[i].cP.vertical_params[0] = from_g->im[i].cP.vertical_params[0];//e
		to_g->im[i].cP.shear_x = from_g->im[i].cP.shear_x;//d
		to_g->im[i].cP.shear_y = from_g->im[i].cP.shear_y;//e
		to_g->im[i].cP.radial = from_g->im[i].cP.radial;
		to_g->im[i].cP.horizontal = from_g->im[i].cP.horizontal;
		to_g->im[i].cP.vertical = from_g->im[i].cP.vertical;
		to_g->im[i].cP.shear = from_g->im[i].cP.shear;
		// copy file names also
		to_g->im[i].name = AllocString(from_g->im[i].name,to_g->im[i].name);
	}
	return true;
}
void  TFormParser::ScaleProjectData(GuiAlignInfo *to_g, double factor, bool round_to_integer)
{
	int i,j;
	double tmp;
	for (i=0; i<to_g->numPts; i++) {
		//
		to_g->cpt[i].ds *= factor;
		for (j=0; j<2; j++) {
			//to_g->cpt[i].x[j] *= factor;
			tmp = to_g->cpt[i].x[j] * factor;
			if (round_to_integer) {
				tmp = floor(tmp+0.5);
			}
			to_g->cpt[i].x[j] = tmp;
			//to_g->cpt[i].y[j] *= factor;
			tmp = to_g->cpt[i].y[j] * factor;
			if (round_to_integer) {
				tmp = floor(tmp+0.5);
			}
			to_g->cpt[i].y[j] = tmp;
		}
	}
	to_g->pano.width *= factor;
	to_g->pano.height *= factor;
	for (i=0; i<to_g->numIm; i++) {
		to_g->im[i].width = factor*to_g->im[i].width + 0.5;
		to_g->im[i].height = factor*to_g->im[i].height + 0.5;
		to_g->im[i].cP.horizontal_params[0] *= factor;
		to_g->im[i].cP.vertical_params[0] *= factor;
		to_g->im[i].cP.shear_x *= factor;
		to_g->im[i].cP.shear_y *= factor;
	}
}
AnsiString  TFormParser::GetOptTypeString(int value)
{
	AnsiString s = " ";
	if ((value) > 0) {
		if (value==1) {
			s += "*";
		} else {
			s += "("+AnsiString(value-2)+")";
		}
	}
	return s;
}
bool  TFormParser::MoveImageAlignInfoData(GuiAlignInfo *gl, int dNr, int sNr)
{
	//
	int i,j;
	GuiImage *im_s,*im_d;
	GuioptVars *opt_s,*opt_d;
	CoordInfo *ci_s,*ci_d;
	if (sNr == dNr) {
		return false; // nothing to do
	}
	im_s	= &(gl->im[sNr]);		// This image is being set
	opt_s 	= &(gl->opt[sNr]);
	ci_s	= &(gl->cim[sNr]);
	im_d	= &(gl->im[dNr]);		// This image is being set
	opt_d 	= &(gl->opt[dNr]);
	ci_d	= &(gl->cim[dNr]);
	memcpy(im_d,im_s,sizeof(GuiImage));
	memcpy(opt_d,opt_s,sizeof(GuioptVars));
	memcpy(ci_d,ci_s,sizeof(CoordInfo));
	im_s->name;
	im_d->name;
	for (i=0; i<gl->numPts; i++) {
		for (j=0; j<2; j++) {
			// change numbers for control points
			if (gl->cpt[i].num[j] == sNr) {
				gl->cpt[i].num[j] = dNr;
			}
		}
	}
	// linked optVars are not moved??
	// triangles are not updated
	return true;
}
bool  TFormParser::SwapImageAlignInfoData(GuiAlignInfo *gl, int dNr, int sNr)
{
	int freeSlotNr;
	ReserveSpace4Image2AlignInfo(gl);
	freeSlotNr = gl->numIm;
	MoveImageAlignInfoData(gl,freeSlotNr,sNr);	// sNr to temp slot
	MoveImageAlignInfoData(gl,sNr,dNr);			// the "other" to s
	MoveImageAlignInfoData(gl,dNr,freeSlotNr);	// temp to d
	return true;
}
bool  TFormParser::DeleteImageFromAlignInfo(GuiAlignInfo *gl, int delNr)
{
	//
	int i;
	if ((delNr >= gl->numIm)||(delNr<0)) {
		return false;	// no such image
	}
	// release dynamically allocated memory
	FreeImAlignInfo(gl,delNr);
	//
	for (i=delNr+1; i<gl->numIm; i++) {
		MoveImageAlignInfoData(gl,i-1,i);
	}
	gl->numIm--;
	return true;
}
//---------------------------------------------------------------------------

void  TFormParser::FormClose(TObject *Sender,
	  TCloseAction &Action)
{
	// Fgl is not reserved in normal order, no delete here
	Fgl = 0;
}
//---------------------------------------------------------------------------

void  TFormParser::FormDestroy(TObject *Sender)
{
	Tag = 0;
	if (Fscript) {
		delete [] Fscript;
	}
	Fscript = 0;
	Fscript_len = 0;
}
//---------------------------------------------------------------------------

void  TFormParser::MemoScriptMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
	TPoint point;
	point = MemoScript->CaretPos;
	EditLNr->Text = point.y+1;
}
//---------------------------------------------------------------------------

void  TFormParser::MemoScriptKeyDown(TObject *Sender, WORD &Key,
	  TShiftState Shift)
{
	TPoint point;
	point = MemoScript->CaretPos;
	EditLNr->Text = point.y+1;
}
//---------------------------------------------------------------------------

#endif
